<?php
/**
 * montonio/module-hire-purchase
 *
 * @category   montonio
 * @package    module-hire-purchase
 * @copyright  Copyright (c) 2020 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */
namespace Montonio\Hirepurchase\Block\Adminhtml;

/**
 * @inheritdoc
 */
class Info extends \Magento\Payment\Block\Info
{

    /**
     *
     * @inheritdoc
     */
    protected function _prepareSpecificInformation($transport = null)
    {
        if (null !== $this->_paymentSpecificInformation) {
            return $this->_paymentSpecificInformation;
        }
        $transport = parent::_prepareSpecificInformation($transport);
        $data = [];
        $extrainfo = $this->getInfo()->getAdditionalInformation('gateway_response');
        if (!empty($extrainfo)) {
            foreach ($extrainfo as $k => $v) {
                $data[(string)__($k)] = $v;
            }
        }

        return $transport->setData(array_merge($data, $transport->getData()));
    }
}
